function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import '../index.less';
import React, { useContext } from 'react';
import classNames from 'classnames';
import DiffContext from '../Context';
import { RenderLabel, RenderContent } from '../Content';
import { getPathNameData } from '../valueUtil';

var Image = function Image(props) {
  var _useContext = useContext(DiffContext),
      before = _useContext.before,
      after = _useContext.after;

  var label = props.label,
      name = props.name,
      rest = _objectWithoutProperties(props, ["label", "name"]);

  var _getPathNameData = getPathNameData(before, after, name),
      isSame = _getPathNameData.isSame,
      beforeValue = _getPathNameData.beforeValue,
      afterValue = _getPathNameData.afterValue;

  return React.createElement("div", Object.assign({
    className: classNames('log-diff-space-divide')
  }, rest), React.createElement(RenderLabel, {
    isSame: isSame,
    label: label
  }), React.createElement(RenderContent, {
    isSame: isSame,
    beforeNode: beforeValue.length ? beforeValue.map(function (li) {
      return React.createElement("a", {
        href: li,
        key: li
      }, li);
    }) : '-',
    afterNode: afterValue.length ? afterValue.map(function (li) {
      return React.createElement("a", {
        href: li,
        key: li
      }, li);
    }) : '-'
  }));
};

export default Image;