function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import '../index.less';
import React, { useContext } from 'react';
import classNames from 'classnames';
import warning from 'rc-util/lib/warning';
import isEqual from 'lodash.isequal';
import DiffContext from '../Context';
import { RenderLabel, RenderContent } from '../Content';
import { getArrayLast, getValue } from '../valueUtil';

var getArrayValue = function getArrayValue(value, name) {
  var result = getValue(value, name);

  if (Array.isArray(result)) {
    return result;
  }

  if (typeof result === 'string') {
    return [result];
  }

  return [];
};

var Radio = function Radio(props) {
  var _useContext = useContext(DiffContext),
      before = _useContext.before,
      after = _useContext.after,
      constants = _useContext.constants;

  var label = props.label,
      name = props.name,
      radioConstants = props.constants,
      rest = _objectWithoutProperties(props, ["label", "name", "constants"]);

  var constantsResult = _objectSpread(_objectSpread({}, constants), radioConstants);

  var hasArray = name.some(function (item) {
    return Array.isArray(item);
  });

  if (hasArray) {
    // 映射类型暂时不支持多维数组
    warning(false, '`Radio` type do not support Array');
    return null;
  }

  var IteratorValue = function IteratorValue(values) {
    if (values.length === 0) {
      return '-';
    }

    return values.map(function (value) {
      return React.createElement("span", {
        className: classNames('log-diff-space'),
        key: "".concat(value)
      }, value && constantsResult[getArrayLast(name)] ? constantsResult[getArrayLast(name)][value] : '');
    });
  };

  var beforeValue = getArrayValue(before, name);
  var afterValue = getArrayValue(after, name);
  var isSame = isEqual(beforeValue, afterValue);
  return React.createElement("div", Object.assign({
    className: classNames('log-diff-space-divide')
  }, rest), React.createElement(RenderLabel, {
    isSame: isSame,
    label: label
  }), React.createElement(RenderContent, {
    isSame: isSame,
    beforeNode: IteratorValue(beforeValue),
    afterNode: IteratorValue(afterValue)
  }));
};

export default Radio;