import get from 'rc-util/lib/utils/get';
import isEqual from 'lodash.isequal';
export function getValue(store, namePath) {
  var value = get(store, namePath);
  return value;
}
export function getArrayLast(arr) {
  return arr[arr.length - 1];
}
export function getPathNameData(before, after, name) {
  var isAllArray = name.every(function (item) {
    return Array.isArray(item);
  });
  var isSame = true;
  var beforeValueResult = [];
  var afterValueResult = [];

  if (isAllArray) {
    name.forEach(function (item) {
      var beforeValue = getValue(before, item);
      var afterValue = getValue(after, item); // eslint-disable-next-line no-unused-expressions

      beforeValue && beforeValueResult.push(beforeValue); // eslint-disable-next-line no-unused-expressions

      afterValue && afterValueResult.push(afterValue);

      if (!isEqual(beforeValue, afterValue)) {
        isSame = false;
      }
    });
  } else {
    var beforeValue = getValue(before, name);
    var afterValue = getValue(after, name);
    isSame = isEqual(beforeValue, afterValue);
    beforeValueResult = beforeValue ? [beforeValue] : [];
    afterValueResult = afterValue ? [afterValue] : [];
  }

  return {
    isSame: isSame,
    beforeValue: beforeValueResult,
    afterValue: afterValueResult
  };
}